﻿Public Class Form1

    '利用平面座標方式表示Form內各PictureBox的位置
    '
    '         1    2    3    4
    '       --------------------
    '    1  | X    O    O    O
    '    2  | O    O    O    O
    '    3  | O    O    O    O
    '    4  | O    O    O    O

    ' 以上 X 為有圖片的PictureBox，起始位置為(1, 1)，其餘的 O 代表無圖片的 PictureBox

    ' 圖片必須使匯入至 「資源」內，匯入方式如下：
    '
    '   1.  在右方「方案總管」，在程式的名稱(MovePix)上按右鍵，再選「內容」；
    '   2.  選擇「資源」；
    '   3.  按「加入資源」旁的下箭咀，選擇「加入現有檔案」，並選擇你的圖像檔案。
    '
    ' 圖片的檔名為images，在這個程式內以 My.Resouces.Images 表示。

    Dim X As Integer = 1   '圖片的起始位置為(1, 1)
    Dim Y As Integer = 1
    Dim max_X As Integer = 4    '座標的水平極限值
    Dim max_Y As Integer = 3    '座標的垂直極限值

    Dim Pos(max_X, max_Y) As PictureBox   '利用二維陣列表示PictureBox

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '把各個PictureBox賦值到二維陣列的相對應位置中

        Pos(1, 1) = PictureBox1   '水平第一行
        Pos(2, 1) = PictureBox2
        Pos(3, 1) = PictureBox3
        Pos(4, 1) = PictureBox4

        Pos(1, 2) = PictureBox5   '水平第二行
        Pos(2, 2) = PictureBox6
        Pos(3, 2) = PictureBox7
        Pos(4, 2) = PictureBox8

        Pos(1, 3) = PictureBox9   '水平第三行
        Pos(2, 3) = PictureBox10
        Pos(3, 3) = PictureBox11
        Pos(4, 3) = PictureBox12

    End Sub


    Private Sub Form1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown

        '檢查所按的鍵：
        '    - 若為Enter鍵，則使用MsgBox顯示現時的圖片的座標位置；
        '    - 若為方向鍵，則改變圖片要顯示的位置。

        If e.KeyCode = Keys.Enter Then
            MsgBox("現在的位置為： (" & X & ", " & Y & ")", MsgBoxStyle.OkOnly, "圖片位置")
        Else
            Pos(X, Y).Image = Nothing   '先把現位置於PictureBox內的圖片清除
            If e.KeyCode = Keys.Right Then      '按右鍵
                If X < max_X Then   '限制X值，以免超越右方極限
                    X += 1
                End If
            ElseIf e.KeyCode = Keys.Left Then   '按左鍵
                If X > 1 Then       '限制X值，以免超越左方極限
                    X -= 1
                End If
            ElseIf e.KeyCode = Keys.Up Then     '按上鍵
                If Y > 1 Then       '限制Y值，以免超越上方極限
                    Y -= 1
                End If
            ElseIf e.KeyCode = Keys.Down Then   '按下鍵
                If Y < max_Y Then   '限制Y值，以免超越下方極限
                    Y += 1
                End If
            ElseIf e.KeyCode = Keys.Enter Then
                MsgBox("現在的位置為： (" & X & ", " & Y & ")", MsgBoxStyle.OkOnly, "圖片位置")
            End If
            Pos(X, Y).Image = My.Resources.images   '更改座標位置後，於PictureBox內顯示圖片
        End If

    End Sub

End Class
